]> arthur.barton.de Git - trigger-rcmd.git/blobdiff - scripts/trigger-rcmd
Fix another (last?) shellcheck(1) warning ...
[trigger-rcmd.git] / scripts / trigger-rcmd
index cfd4d790df7c531e9fca9d6482f3cda984a9fa4e..102fe162754d5e25922b9feafeee233a3f9bb5b4 100755 (executable)
@@ -1,7 +1,7 @@
 #!/bin/sh
 #
 # trigger-rcmp: Trigger remote commands
-# Copyright (c)2014-2016 Alexander Barton (alex@barton.de)
+# Copyright (c)2014-2020 Alexander Barton (alex@barton.de)
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -10,7 +10,8 @@
 # Please read the file COPYING, README and AUTHORS for more information.
 #
 
-NAME=$(basename "$0")
+BASENAME=$(basename "$0")
+NAME="$BASENAME"
 RCMD_D="/usr/local/etc/rcmd.d"
 
 PATH="$PATH:/usr/local/sbin:/usr/sbin"
@@ -32,37 +33,29 @@ do_rcmd() {
 
        # Read in job/configuration file, but ignore shellcheck(1) warnings:
        # shellcheck disable=1090
-       . "$cnf"
-
-       if [ $? -ne 0 ]; then
+       if ! . "$cnf"; then
                echo "$NAME: Failed to read \"$cnf\"!"
                return 2
        fi
 
-       NAME="$NAME($1)"
-
        echo "$NAME: Checking system \"$SYSTEM\" ..."
-       fping -c1 -q "$SYSTEM" 2>/dev/null
-       if [ $? -ne 0 ]; then
+       if ! fping -c1 -q "$SYSTEM" 2>/dev/null; then
                if [ -n "$NO_WAKE" ]; then
                        echo "$NAME: \"$SYSTEM\" seems to be down, skipping job."
                        return 9
                fi
 
                echo "$NAME: \"$SYSTEM\" seems to be down, wake it up ..."
-               etherwake -b -i "$IFACE" "$(echo "$SYSTEM" | cut -d'.' -f1)"
-               if [ $? -ne 0 ]; then
+               if ! etherwake -b -i "$IFACE" "$(echo "$SYSTEM" | cut -d'.' -f1)"; then
                        echo "$NAME: Failed to wake \"$SYSTEM\"!" >&2
                        return 3
                fi
                echo "$NAME: Waiting for \"$SYSTEM\" to respond ..."
                for i in $(seq 1 $TIMEOUT); do
-                       fping -c1 -q "$SYSTEM" 2>/dev/null
-                       [ $? -ne 0 ] || break
+                       fping -c1 -q "$SYSTEM" 2>/dev/null && break
                        sleep 1s
                done
-               fping -c1 -q "$SYSTEM" 2>/dev/null
-               if [ $? -ne 0 ]; then
+               if ! fping -c1 -q "$SYSTEM" 2>/dev/null; then
                        echo "$NAME: Failed to wake \"$SYSTEM\"!" >&2
                        return 4
                fi
@@ -103,8 +96,7 @@ do_rcmd() {
                if [ "$rsys_users" = "0" ]; then
                        echo "$NAME: Power off \"$SYSTEM\" again ..."
                        # shellcheck disable=2029
-                       ssh -o PreferredAuthentications=publickey -q "$SYSTEM" "sync; shutdown -hP $SHUTDOWN_TIME" >/dev/null
-                       if [ $? -ne 0 ]; then
+                       if ! ssh -o PreferredAuthentications=publickey -q "$SYSTEM" "sync; shutdown -hP $SHUTDOWN_TIME" >/dev/null 2>&1; then
                                echo "$NAME: Failed to power off \"$SYSTEM\"!" >&2
                                return 5
                        fi
@@ -153,6 +145,7 @@ while [ $# -gt 0 ]; do
                r=1
        else
                echo "$NAME: Working on \"$1\" - $(date "+%Y-%m-%d %H:%M:%S")"
+               NAME="$BASENAME($1)"
                lck="/run/lock/$NAME-$1.lock"
                if lockfile-create --quiet --use-pid --retry 2 --lock-name "$lck"; then
                        do_rcmd "$1" ; r=$?
@@ -162,9 +155,16 @@ while [ $# -gt 0 ]; do
                        echo "$NAME: Failed to acquire lock file, skipping job! ($lck)"
                        r=1
                fi
+               NAME=$BASENAME
+       fi
+       if [ $r -ne 0 ]; then
+               # Exit code indicates an error. But only flag this as error
+               # when target should have been woken up and the indicated error
+               # is not "system down" (9).
+               [ -z "$NO_WAKE" ] || [ $r -ne 9 ] && result=1
        fi
-       [ $r -ne 0 ] && result=1
        shift
-       [ $# -gt 0 ] && echo
 done
+
+echo "$NAME: All done, exit code $result - $(date "+%Y-%m-%d %H:%M:%S")"
 exit $result